Attribute VB_Name = "Vanguard"
Option Explicit

Private projectIndentifier          As String           'Project Indentifier - a field in each record
Private vanguardEdiPath             As String
Private vanguardEdiBakPath          As String
Private vanguardEdiFile             As String
Private vanguardIni                 As String
Private vanguardCarrier             As String           'EDI record vanguard carrier
Private serviceLevel                As String           'EDI record service level

Public Sub Vanguard320()
    
    'Receives: Nothing.
    'Returns: Nothing.
    'Called from Clippership_OnEachUser (ax_320)
    'Calls code to initialize variables pointing to Vanguard rate files.
    
    VanguardInit

End Sub

Public Sub Vanguard620()

    'Receives: Nothing.
    'Returns: Nothing.
    'Called from Clippership_AfterCarrierLookup (ax_620)
    'Calculates and store in shp_chg the rate that Vanguard will charge OOS Medical for Purolator
    
    Dim carrier As String
    carrier = Trim(cshost.GetVar("xcarrier"))
    
    'Get billable weight
    Dim billWgt As Currency
    billWgt = GetbillableWeight(carrier)

End Sub

'Public Sub CreateVanguardEDIFile(retransmit As String)
'
'    'Receives: retransmit flag to indicate if to ignore the already written back to host flag when creating the EDI file
'    'Returns : Nothing
'    'Called from Clippership.TransmitVanguardEDI()
'    'Creates the edi file for Vanguard
'
'    PopStatus "EDI File Creation", "Please wait...Creating EDI File."
'
'    'Get name of current daily file (with full path)
'    Dim tempDailyFile As String
'    If retransmit = "Y" Then
'        tempDailyFile = cshost.GetVar("xreport")
'    Else
'        tempDailyFile = cshost.dailyFile
'    End If
'
'    If Alltrim(tempDailyFile) <> "" Then
'        'Index current daily file on PKGID
'        DbfIndex tempDailyFile, "pkgid"
'
'        Dim myCondition As String
'        myCondition = "((CARRIER = 'D' .and. .not. (CARRIER = 'DHI')) .or. (CARRIER = 'P')) .and. status <> 'VOID'"
'        If retransmit = "N" Then
'            'Add Already Written Back to host flag Field to condition in not retransmiting
'            myCondition = myCondition & " .and. " & gVangEDIProcFlagField & " <> 'Y' "
'        End If
'
'        DbfProcess tempDailyFile, "VanguardPackageLevel", myCondition
'
'        DeleteFileIndex tempDailyFile
'    End If
'    KillStatus
'
'End Sub

'Public Sub VanguardPackageLevel()
'
'    'Receives: Nothing
'    'Returns : Nothing
'    'Called from CreateVanguardEDIFile()- has to be public as it is used by a DbfProcess() function
'    'Creates a package level record in the EDI file for each record in the daily file
'
'    Dim ediString As String
'    ediString = ""
'
'    'Populate EDI record carrier and service level
'    PopCarrierAndServiceLevel Alltrim(XV1("carrier"))
'
'    ediString = ediString & qt & Alltrim(XV1("pkgid")) & qt & ","                   ' Pack Ticket Number
'    ediString = ediString & qt & Alltrim(DtoC(XV1("Date"))) & qt & ","              ' Date Shipped
'    ediString = ediString & qt & vanguardCarrier & qt & ","                         ' Carrier
'    ediString = ediString & qt & Alltrim(XV1("track_no")) & qt & ","                ' Tracking Number
'    ediString = ediString & qt & Alltrim(XV1("cust")) & qt & ","                    ' Customer Number
'
'
'    If Trim(XV1("shipto1")) = "" Then
'        If Trim(XV1("shipto2")) = "" Then
'            If Trim(XV1("shipto3")) = "" Then
'                ediString = ediString & qt & Alltrim(XV1("shipto4")) & qt & ","     ' Customer Name
'                ediString = ediString & qt & Alltrim(XV1("shipto5")) & qt & ","     ' Address Line 1
'                ediString = ediString & qt & "" & qt & ","                          ' Address Line 2
'            Else
'                ediString = ediString & qt & Alltrim(XV1("shipto3")) & qt & ","     ' Customer Name
'                ediString = ediString & qt & Alltrim(XV1("shipto4")) & qt & ","     ' Address Line 1
'                ediString = ediString & qt & Alltrim(XV1("shipto5")) & qt & ","     ' Address Line 2
'            End If
'        Else
'            ediString = ediString & qt & Alltrim(XV1("shipto2")) & qt & ","         ' Customer Name
'            ediString = ediString & qt & Alltrim(XV1("shipto3")) & qt & ","         ' Address Line 1
'            ediString = ediString & qt & Alltrim(XV1("shipto4")) & qt & ","         ' Address Line 2
'        End If
'    Else
'        ediString = ediString & qt & Alltrim(XV1("shipto1")) & qt & ","             ' Customer Name
'        ediString = ediString & qt & Alltrim(XV1("shipto2")) & qt & ","             ' Address Line 1
'        ediString = ediString & qt & Alltrim(XV1("shipto3")) & qt & ","             ' Address Line 2
'    End If
'
'    ediString = ediString & qt & Alltrim(XV1("shipto6")) & qt & ","                 ' City
'    ediString = ediString & qt & Alltrim(XV1("shipto7")) & qt & ","                 ' Province / State
'
'
'    ediString = ediString & qt & Alltrim(XV1("zip")) & qt & ","                     ' Postal Code
'    ediString = ediString & qt & Alltrim(XV1("country")) & qt & ","                 ' Country
'    ediString = ediString & qt & Space(10) & qt & ","                               ' Attn To
'    ediString = ediString & qt & Alltrim(XV1("phone")) & qt & ","                   ' Phone
'    ediString = ediString & qt & "1" & qt & ","                                     ' Pieces
'    ediString = ediString & qt & Alltrim(Str(XV1("act_wgt"), 10, 2)) & qt & ","     ' Weight
'    ediString = ediString & qt & Alltrim(XV1("PROD")) & qt & ","                    ' Shipper Reference
'    ediString = ediString & qt & Space(10) & qt & ","                               ' Special Instructions
'    ediString = ediString & qt & Alltrim(Str(XV1("ins_amt"), 8, 2)) & qt & ","      ' Declared Value
'    ediString = ediString & qt & serviceLevel & qt & ","                            ' Service Level Description
'    ediString = ediString & qt & projectIndentifier & qt & ","                      ' Project Identifier
'    ediString = ediString & qt & GetPaymentType(Str(XV1("pay_flag"))) & qt & ","    ' Payment Type
'    ediString = ediString & qt & Alltrim(Str(XV1("dim_length"))) & qt & ","
'    ediString = ediString & qt & Alltrim(Str(XV1("dim_width"))) & qt & ","
'    ediString = ediString & qt & Alltrim(Str(XV1("dim_height"))) & qt
'
'    Host2.AppendLineTo vanguardEdiFile, ediString
'
'    ' Set the SPP_FLAG to "Y" to ensure that this package does not get retransmitted.
'    DbfReplace gVangEDIProcFlagField, "Y"
'
'End Sub
'
'Public Sub TransmitVanguardEDIFile()
'
'    'Receives: Nothing
'    'Returns : Nothing
'    'Called from CreateVanguardEDIFile() - has to be public as it is used by a DbfProcess() function
'    'Creates the edi file the name - a prefix and a sequential number,
'    'Backup the EDI file
'    'Transmits the EDI file using FTP protocol
'
'    Dim executeFTP As String
'    Dim ftpCommand As String
'    Dim ediNumber As Integer
'    Dim ediString As String
'    Dim finalFile As String
'    Dim finalBak As String
'
'    ' Read in the Vanguard EDI file number
'    ediNumber = Val(IniRead(vanguardIni, "EDI", "EDIcounter", ""))
'    If ediNumber < 1 Then
'        ediNumber = 1
'    Else
'        ediNumber = ediNumber + 1
'    End If
'    finalFile = vanguardEdiPath & projectIndentifier & "_" + PadL(Alltrim(Str(ediNumber)), 5, "0") + ".csv"
'    finalBak = vanguardEdiBakPath & projectIndentifier & "_" + PadL(Alltrim(Str(ediNumber)), 5, "0") + ".csv"
'
'    ' Update the Vanguard INI file with the new file number
'    ediString = Str(ediNumber)
'    IniWrite vanguardIni, "EDI", "EDIcounter", ediString
'
'    fCopy vanguardEdiFile, finalFile
'    fCopy vanguardEdiFile, finalBak
'
'    fErase vanguardEdiFile
'
'    If fFirst(vanguardEdiPath & "*.csv") <> "" Then
'        'ftpCommand = "C:\progra~1\transs~1\ftpcon~1\runscr~1.exe " & "vanguard.ftp " & vanguardEdiPath & "*.*"
'        ftpCommand = "C:\progra~2\transs~1\ftpcon~1\runscr~1.exe " & ProjectDir() & "vanguard.ftp " & vanguardEdiPath & "*.*"
'        'Host2.AppendLineTo "c:\temp\tranpath.txt", ftpCommand
'        'Execute FTP Control to send the EDI file
'        WinExecMod (ftpCommand)
'    End If
'
'End Sub

Private Sub VanguardInit()

    'Receives: Nothing.
    'Returns: Nothing.
    'Initializes variables

    vanguardIni = cshost.ShipDir & "vanguard.ini"
    vanguardEdiPath = cshost.ShipDir & "evcanedi\vanguard\"
    vanguardEdiFile = vanguardEdiPath & "vanguard.txt"
    vanguardEdiBakPath = vanguardEdiPath & "bak\"
    projectIndentifier = "OOS"

End Sub

Private Function GetbillableWeight(carrier As String) As Currency

    'Receives: Clippership carrier code
    'Returns: billable weight
    'Calculate billable weight

    Dim actWgt  As Currency
    Dim dimWgt  As Currency
    Dim billWgt As Currency

    actWgt = Val(cshost.GetVar("xact_wgt"))
    dimWgt = Val(cshost.GetVar("xdim_wgt"))

    billWgt = actWgt
    If dimWgt > billWgt Then
        billWgt = dimWgt
    End If

    GetbillableWeight = billWgt

End Function
'
'Private Sub PopCarrierAndServiceLevel(csCarrier As String)
'
'    'Receives: Clippership carrier name
'    'Returns: Nothing
'    'Pop EDI record carrier and service level vars
'
'    Select Case csCarrier
'        Case "PGG"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Ground"
'        Case "PXX"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Express"
'        Case "PXT"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Express 10:30AM"
'        Case "PXN"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Express 9AM"
'        Case "PLL"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Envelope"
'        Case "PLN"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Envelope 9AM"
'        Case "PLT"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Envelope 10:30AM"
'        Case "PPP"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Pack"
'        Case "PPN"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Pack 9AM"
'        Case "PPT"
'            vanguardCarrier = "PURO"
'            serviceLevel = "Pack 10:30AM"
'        Case "DHG"
'            vanguardCarrier = "LOOMIS"
'            serviceLevel = "Ground"
'        Case "DHE"
'            vanguardCarrier = "LOOMIS"
'            serviceLevel = "18:00"
'        Case "DHT"
'            vanguardCarrier = "LOOMIS"
'            serviceLevel = "12:00"
'        Case "DH9"
'            vanguardCarrier = "LOOMIS"
'            serviceLevel = "9:00"
'
'        Case Else
'            vanguardCarrier = "INVALID"
'            serviceLevel = "INVALID"
'    End Select
'
'End Sub

Private Function GetPaymentType(csCarrier As String) As String

    'Receives: Clippership pay flag
    'Returns: Nothing
    'Pop EDI record payment type
    
    Select Case XV1("pay_flag")
        Case "1"
            ' Prepaid
            GetPaymentType = "P"
        Case "2"
            ' Collect
            GetPaymentType = "C"
        Case "3"
            ' Third Party
            GetPaymentType = "T"
        Case Else
            ' Invalid Payment Type
            GetPaymentType = "X"
    End Select
    
End Function
